'''
Универсальный клиент библиотеки lite
--------------------------------------------------------------------------------
История изменений в конце файла
OldBean, 28.07.2021
'''
import socket
from threading import Thread
import readline
import sys
#-------------------------------------------------------------------------------
if len(sys.argv) > 1:
  server_addr = (sys.argv[1], 5238)
else:
  server_addr = ('localhost', 5238)

print(server_addr)
#-------------------------------------------------------------------------------
def input_thread():
  ''' Ввод сообщений. Функция работает в отдельном потоке.
  '''
  global client_msg
  while True:
    client_msg = input()
#    print(client_msg)
    sock.send(client_msg.encode())
#-------------------------------------------------------------------------------
def recv_thread(sock):
  ''' Получение сообщений от сервера. Функция работает в отдельном потоке.
  '''
  global server_msg
  while True:
    server_msg = sock.recv(32768).decode()
    print(server_msg)
#-------------------------------------------------------------------------------
client_msg = '' # Сообщение клиента для отправки серверу
server_msg = '' # Сообщение, полученное от сервера
sock = socket.socket()
#-------------------------------------------------------------------------------
try:
  sock.connect(server_addr)
  print('Соединение установлено. Завершение работы - bye')

  thread_inp = Thread(target=input_thread, daemon=True)
  thread_inp.start()

  thread_recv = Thread(target=recv_thread, args=(sock,), daemon=True)
  thread_recv.start()

  while True:
    if client_msg[:3] == 'bye' or server_msg == 'bye':
      print('Завершение работы клиента')
      break
except Exception as e:
  print("Ошибка: ", e)
finally:
  sock.close()
  import subprocess
  subprocess.call('reset')

#-------------------------------------------------------------------------------
''' Список изменений
28.07.2021 1. Косметические правки, добавление комментариев
'''
#-------------------------------------------------------------------------------
